#include "GameRect.h"
#include "Screen.h"

#include <sqobject/sqratfunc.h>

extern Screen *screen;

/**
 * RXgN^
 */
GameRect::GameRect(HSQUIRRELVM vm) : GameObject(), ScreenObject(::screen, 1), left(0), top(0), width(1), height(1), color(0xffffffff)
{
	int n = sq_gettop(vm);
	if (n >= 2) sq_getfloat(vm, 2, &left);
	if (n >= 3) sq_getfloat(vm, 3, &top);
	if (n >= 4) sq_getfloat(vm, 4, &width);
	if (n >= 5) sq_getfloat(vm, 5, &height);
	if (n >= 6) sq_getinteger(vm, 6, &color);
}

/**
 * fXgN^
 */
GameRect::~GameRect()
{
}


// \
struct CUSTOMVERTEX
{
	FLOAT x, y, z;
	FLOAT rhw;
	D3DCOLOR color;
};
#define D3DFVF_CUSTOMVERTEX (D3DFVF_XYZRHW | D3DFVF_DIFFUSE)

// `揈
void
GameRect::render(LPDIRECT3DDEVICE9 pD3DDevice)
{
	float right  = left + width;
	float bottom = top + height;
	CUSTOMVERTEX v[4] = {
		// x, y, z, color
		{ left,  top,    0.0f, 1.0f, color },
		{ right, top,    0.0f, 1.0f, color },
		{ right, bottom, 0.0f, 1.0f, color },
		{ left,  bottom, 0.0f, 1.0f, color }
	};
	// alpha
	pD3DDevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
	pD3DDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);
	pD3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
	pD3DDevice->SetFVF(D3DFVF_CUSTOMVERTEX);
	pD3DDevice->DrawPrimitiveUP(D3DPT_TRIANGLEFAN, 2, v, sizeof v[0]);
}

/**
 * NXo^
 */
void
GameRect::registerClass()
{
	HSQUIRRELVM vm = sqobject::getGlobalVM();
	Sqrat::DerivedClass<GameRect, sqobject::Object, sqobject::VMConstructor<GameRect>> cls(vm);
	SQFUNC(GameRect, setIndex);
	SQFUNC(GameRect, getIndex);
	SQFUNC(GameRect, setVisible);
	SQFUNC(GameRect, getVisible);
	SQFUNC(GameRect, setLeft);
	SQFUNC(GameRect, getLeft);
	SQFUNC(GameRect, setTop);
	SQFUNC(GameRect, getTop);
	SQFUNC(GameRect, setWidth);
	SQFUNC(GameRect, getWidth);
	SQFUNC(GameRect, setHeight);
	SQFUNC(GameRect, getHeight);
	SQFUNC(GameRect, setColor);
	SQFUNC(GameRect, getColor);
	// sqrat  set/get ㏑ sqobject @\ƐƂ
	sqobject::OverrideSetGet<GameRect>::Func(vm);
	Sqrat::RootTable(vm).Bind(_SC("GameRect"), cls);
}
