#ifndef SQPLUSFUNC_H
#define SQPLUSFUNC_H

#include <sqplus.h>

/**
 * e폈pev[g
 */
template <typename T>
struct SQTemplate {
  static SQRESULT release(SQUserPointer up, SQInteger size) {
	T* self = (T*)up;
	if (self){ 
	  self->destructor();
	  delete self;
	}
	return SQ_OK;
  }
  static SQRESULT _constructor(HSQUIRRELVM v, T *data) {
	if (data) {
	  data->initSelf(v);
	  SqPlus::PostConstruct<T>(v, data, release);
	  return SQ_OK;
	} else {
	  return SQ_ERROR;
	}
  }
  static SQRESULT constructor(HSQUIRRELVM v) {
	T *data = new T();
	if (data) {
	  data->initSelf(v);
	  SqPlus::PostConstruct<T>(v, data, release);
	  return SQ_OK;
	} else {
	  return SQ_ERROR;
	}
  }
  static SQRESULT vconstructor(HSQUIRRELVM v) {
	T *data = new T(v);
	if (data) {
	  SqPlus::PostConstruct<T>(v, data, release);
	  return SQ_OK;
	} else {
	  return SQ_ERROR;
	}
  }
  static SQRESULT noconstructor(HSQUIRRELVM v) {
	return sq_throwerror(v, "can't create instance");
  }
  static SQRESULT destructor(HSQUIRRELVM v) {
	  return SQ_OK;
  }
};

/**
 * Y^̃IuWFNgX^bNɊi[B
 * initSelf̌Ăяočs
 * @param name ^
 * @param obj IuWFNg
 * @return SQRESULT
 */
template <typename T>
SQRESULT pushsqobj(HSQUIRRELVM v, const SQChar *className, T *obj) {
	if (obj && CreateNativeClassInstance(v, className, obj, SQTemplate<T>::release)) {
		obj->initSelf(v,-1);
		return 1;
	} else {
		return sq_throwerror(v, "can't create instance");
	}
}

/**
 * Y^̃IuWFNgX^bNɊi[Bsꍇ̓IuWFNgdelete
 * initSelf̌Ăяočs
 * @param name ^
 * @param obj IuWFNg
 * @return SQRESULT
 */
template <typename T>
SQRESULT pushnewsqobj(HSQUIRRELVM v, const SQChar *className, T *obj) {
	if (obj && CreateNativeClassInstance(v, className, obj, SQTemplate<T>::release)) {
		obj->initSelf(v,-1);
		return 1;
	} else {
		delete obj;
		return sq_throwerror(v, "can't create instance");
	}
}

// ------------------------------------------------------------------
// NXo^p}N
// ------------------------------------------------------------------

// ----------------------------------------------
// NX`p}N
// NX̖OQƂ̂߂炩 DECLARE_INSTANCE_TYPE_* Ō^`ĂKv܂

// NX`(ʏp)
#define SQCLASS(Class) SQClassDefNoConstructor<Class> cls(TypeInfo<Class>().typeName)
// NX` sqobject::Objectpi^:Object)
#define SQCLASSOBJ(Class) SQClassDefNoConstructor<Class,Object> cls(TypeInfo<Class>().typeName, SQOBJECTNAME)
// NX` Cӌp
#define SQCLASSEX(Class,Parent) SQClassDefNoConstructor<Class,Parent> cls(TypeInfo<Class>().typeName, TypeInfo<Parent>().typeName)

// ----------------------------------------------
// RXgN^`p}N

// sqobject::Object nRXgN^EȂ
#define SQCONSTRUCTOR(Class) cls.staticFuncVarArgs(SQTemplate<Class>::constructor, _SC("constructor"))
#define SQCONSTRUCTOR_(Class, TypeCheck) cls.staticFuncVarArgs(SQTemplate<Class>::constructor, _SC("constructor"), TypeCheck)

// sqobject::Object nRXgN^EHSQUIRREL
#define SQVCONSTRUCTOR(Class) cls.staticFuncVarArgs(SQTemplate<Class>::vconstructor, _SC("constructor"))
#define SQVCONSTRUCTOR_(Class,TypeCheck) cls.staticFuncVarArgs(SQTemplate<Class>::vconstructor, _SC("constructor"), TypeCheck)

// NX static SQRESULT constructor(HSQUIRRELVM) ꍇp
#define SQSCONSTRUCTOR(Class) cls.staticFuncVarArgs(Class::constructor, _SC("constructor"))
#define SQSCONSTRUCTOR_(Class,TypeCheck) cls.staticFuncVarArgs(Class::constructor, _SC("constructor"), TypeCheck)

// RXgN^
#define SQNOCONSTRUCTOR(Class) cls.staticFuncVarArgs(SQTemplate<Class>::noconstructor, _SC("constructor"))

// ORXgN^
#define SQMYCONSTRUCTOR(constructor) cls.staticFuncVarArgs(constructor, _SC("constructor"))
#define SQMYCONSTRUCTOR_(constructor, TypeCheck) cls.staticFuncVarArgs(constructor, _SC("constructor"), TypeCheck)

// fXgN^()
#define SQDESTRUCTOR(Class) cls.staticFuncVarArgs(SQTemplate<Class>::destructor, _SC("destructor"))

// ----------------------------------------------
// t@NVo^p}N

#define SQFUNC(Class, Name) cls.func(&Class::Name,_SC(#Name))
#define SQFUNC_(Class, Name, TypeCheck) cls.func(&Class::Name,_SC(#Name), TypeCheck)
#define SQVFUNC(Class, Name) cls.funcVarArgs(&Class::Name,_SC(#Name))
#define SQVFUNC_(Class, Name, TypeCheck) cls.funcVarArgs(&Class::Name,_SC(#Name), TypeCheck)
#define SQSFUNC(Class, Name) cls.staticFunc(&Class::Name,_SC(#Name))
#define SQSFUNC_(Class, Name, TypeCheck) cls.staticFunc(&Class::Name,_SC(#Name), TypeCheck)
#define SQSVFUNC(Class, Name) cls.staticFuncVarArgs(&Class::Name,_SC(#Name))
#define SQSVFUNC_(Class, Name, TypeCheck) cls.staticFuncVarArgs(&Class::Name,_SC(#Name), TypeCheck)

#define SQPUSH(v, obj) pushsqobj(v, GetTypeName(*obj), obj)
#define SQPUSHNEW(v, obj) pushnewsqobj(v, GetTypeName(*obj), obj)
#define SQSETINSTANCE(v, Class, param) SQTemplate<Class>::_constructor(v, new Class param)

#endif
