/*
 * copyright (c)2009 http://wamsoft.jp
 * zlib license
 */
#ifndef __SQTHREAD_H__
#define __SQTHREAD_H__

#ifndef SQTHREAD
#define SQTHREAD Thread
#define SQTHREADNAME _SC("Thread")
#endif

#include <stdio.h>
#include "sqobject.h"

/**
 * t@C񓯊ɊJ
 * @param filename XNvgt@C
 * @return t@Cnh
 */
extern void *sqobjOpenFile(const SQChar *filename, bool binary=false);

/**
 * t@CJꂽǂ̃`FbN
 * @param handler t@Cnh
 * @param dataPtr f[^i[AhX(o)
 * @param dataSize f[^TCY(o)
 * @return [hĂ true
 */
extern bool sqobjCheckFile(void *handler, const char **dataAddr, int *dataSize);

/**
 * t@C
 * @param handler t@Cnh
 */
extern void sqobjCloseFile(void *handler);

namespace sqobject {

class Thread : public Object {

protected:
	long _currentTick; ///< ̃Xbh̎s

	ObjectInfo _scriptName; ///< XNvg
	
	void *_fileHandler; ///< ̃XbhJƂĂt@C

	// Xbhf[^
	ObjectInfo _thread;

	// sXNvg
	ObjectInfo _func;

	// Xg
	ObjectInfo _args;

	// systemp҂
	ObjectInfo _waitSystem;
	// ҂Ώ
	ObjectInfo _waitList;
	// ҂
	SQInteger _waitTimeout;

	// ҂̌
	ObjectInfo _waitResult;
	
	/// IR[h
	ObjectInfo _exitCode;
	
	/**
	 * Xbh
	 */
	enum ThreadStatus {
		THREAD_NONE,           // 
		THREAD_LOADING_FILE,   // t@C[h
		THREAD_LOADING_FUNC,   // ֐[h
		THREAD_STOP,   // ~
		THREAD_RUN,    // 쒆
		THREAD_WAIT,   // ҂
	} _status;

	/**
	 * @return ҂
	 */
	bool isWait();

	/**
	 * @return YXbhƌ݊Ǘ̃XbhvĂ true
	 */
	bool isSameThread(HSQUIRRELVM v);

public:
	// RXgN^
	Thread();

	// RXgN^
	Thread(HSQUIRRELVM v);
	
	// fXgN^
	~Thread();

protected:
	/**
	 * Xbh񏉊
	 */
	void _init();

	/**
	 * IuWFNgɑ΂҂NA
	 * @param status LZ̏ꍇ true
	 */
	void _clearWait();

	/**
	 * j
	 */
	void _clear();

	/**
	 * exit
	 */
	void _exit();
	
	// ------------------------------------------------------------------
	//
	// Object ̐p
	//
	// ------------------------------------------------------------------
	
public:

	/**
	 * gKɑ΂҂
	 * @param name gK
	 * @return YIuWFNg҂Ăꍇ true
	 */
	bool _notifyTrigger(const SQChar *name);

	/**
	 * IuWFNgɑ΂҂
	 * @param target ҂Ώ
	 * @return YIuWFNg҂Ăꍇ true
	 */
	bool _notifyObject(ObjectInfo &target);
	
	// ------------------------------------------------------------------
	//
	// \bh
	//
	// ------------------------------------------------------------------

protected:

	/**
	 * p:fork BXbhP VMPUSH
	 * @param v squirrelVM
	 * @return  true
	 */
	static bool _fork(HSQUIRRELVM v);

	/**
	 * p: wait
	 * @param v squirrelVM
	 * @param idx Y idx ȍ~ɂ̂҂
	 */
	void _wait(HSQUIRRELVM v, int idx=2);

	/**
	 * p: system̑҂BX^bN擪ɂXbh҂
	 * @param v squirrelVM
	 */
	void _system(HSQUIRRELVM v);

	
	/**
	 * p: exec
	 * @param v squirrelVM
	 * @param idx ̃CfbNXɂ̂sJnBȂXNvgAt@NVȂ璼
	 */
	void _exec(HSQUIRRELVM v, int idx=2);

	/**
	 * ݂̃IuWFNgsXbhƂēo^
	 */
	void _entryThread(HSQUIRRELVM v);
	
public:
	/**
	 * ҂o^
	 */
	SQRESULT wait(HSQUIRRELVM v);

	/**
	 * wait̃LZ
	 */
	void cancelWait();

	/**
	 * sJn
	 * @param func sΏۃt@NVB̏ꍇYXNvgǂݍ
	 */
	SQRESULT exec(HSQUIRRELVM v);

	/**
	 * sI
	 * @param exitCode IR[h
	 */
	SQRESULT exit(HSQUIRRELVM v);

	/**
	 * exitCode擾
	 */
	SQRESULT getExitCode(HSQUIRRELVM v);
	
	/**
	 * s~
	 */
	void stop();

	/**
	 * sĊJ
	 */
	void run();

	/**
	 * @return sXe[^X
	 */
	int getStatus();

	/**
	 * @return ݎ
	 */
	int getCurrentTick() {
		return _currentTick;
	}

	// ------------------------------------------------------------------
	//
	// s
	//
	// ------------------------------------------------------------------
	
protected:

	/**
	 * Xbh̃G[̕\
	 */
	void printError();

	/**
	 * Xbh̃C
	 * @param diff oߎ
	 * @return XbhsIȂ true
	 */
	bool _main(long diff);

public:

	/**
	 * Xbh
	 */
	static void init();

	/*
	 * ԍXV
	 * @param diff oߎ
	 */
	static void update(long diff);
	
	/*
	 * sC[v
	 * ݑ݂Xbh𑍂Ȃ߂łPxsB
	 * VXe{̂̃C[v(Cxg{摜)
	 * 1xĂяoƂŋ@\Bꂼ̃Xbh́A
	 * 疾I suspend() ܂ waitñ\bhĂяoď
	 * ̃XbhɈϏKvB
	 * @return 쒆̃Xbh̐
	 */
	static int main();

	/**
	 * XNvgsJnp
	 * @param scriptName XNvg
	 * @param argc ̐
	 * @param argv 
	 * @return Ȃ true
	 */
	static bool fork(const SQChar *scriptName, int argc=0, const SQChar **argv=NULL);

	/**
	 * Xbh̔j
	 */
	static void done();

	/**
	 * Xbh
	 */
	static int getThreadCount();

	// -------------------------------------------------------------
	// Xbhp
	// -------------------------------------------------------------

public:
	static long currentTick;  ///< ̌Ăяo
	static long diffTick;     ///< Ăяo
	
protected:
	static ObjectInfo threadList; ///< Xbhꗗ
	static ObjectInfo newThreadList; ///< Xbhꗗ

	// -------------------------------------------------------------
	// O[o\bhp
	// -------------------------------------------------------------

	/**
	 * ݎ̎擾
	 */
	static SQRESULT global_getCurrentTick(HSQUIRRELVM v);

	/**
	 * ̎擾
	 */
	static SQRESULT global_getDiffTick(HSQUIRRELVM v);
	
	/*
	 * @return ݂̃XbhԂ
	 */
	static SQRESULT global_getCurrentThread(HSQUIRRELVM v);
	
	/*
	 * @return ݂̃XbhꗗԂ
	 */
	static SQRESULT global_getThreadList(HSQUIRRELVM v);

	/*
	 * XNvgVXbhƂĎs
	 *  return Thread(func); 
	 * @param func XbhŎst@NV
	 * @return VXbh
	 */
	static SQRESULT global_fork(HSQUIRRELVM v);

	/**
	 * @return ݎs̃XbhIuWFNg(Thread*)
	 */
	static Thread *getCurrentThread(HSQUIRRELVM v);

	/**
	 * XNvg؂ւ
	 * @param func XbhŎst@NV
	 */
	static SQRESULT global_exec(HSQUIRRELVM v);

	/**
	 * sXbh̏I
	 * @param exitCode IR[h
	 */
	static SQRESULT global_exit(HSQUIRRELVM v);

	/**
	 * XNvgsĂ̏I҂
	 * @param func XbhŎst@NV
	 * @return XNvg̏IR[h
	 */
	static SQRESULT global_system(HSQUIRRELVM v);
	
	/**
	 * sXbh̏҂
	 * @param target int:ԑ҂(ms), string:gK҂, obj:IuWFNg҂
	 * @param timeout ^CAEg(ȗ͖ɑ҂)
	 * @return ҂LZꂽ true
	 */
	static SQRESULT global_wait(HSQUIRRELVM v);

	/**
	 * SXbhւ̃gKʒm
	 * @param name ҂gK
	 */
	static SQRESULT global_trigger(HSQUIRRELVM v);

public:
	/**
	 * O[o\bh̓o^
	 */
	static void registerGlobal();

	/**
	 * NX̓o^
	 */
	static void registerClass();

};

};

#endif
